{   
   uError, general error handling support
   Copyright (C) 2006. - 2010. Dejan Boras

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   Started On:    26.12.2006.
   Last update:   26.03.2011.
}

{$MODE OBJFPC}{$H+}
UNIT uError;

INTERFACE

CONST
   {error constants}
   {$INCLUDE errorcodes.inc}

VAR
   ioE: longint = eNONE;

{ GENERAL }
{store and return result of IOResult}
function ioerror(): longint;
{ignore an IO error}
procedure ioErrorIgn();

{adds an error procedure}
procedure eAddErrorProc(var newerrorproc: TErrorProc;
                        var olderrorproc: TErrorProc);

{get the name of an error code}
function eGetCodeName(code: longint): string;

IMPLEMENTATION

{ GENERAL }

function ioerror(): longint;
begin
   ioE := IOResult; result := ioE;
end;

procedure ioErrorIgn();
begin
   IOResult();
end;

procedure eAddErrorProc(var newerrorproc: TErrorProc;
                        var olderrorproc: TErrorProc);
begin
   {check the validity of arguments passed}
   if(newerrorproc <> nil) and (olderrorproc = nil) then begin     
      {add a new error procedure}
      olderrorproc := ErrorProc;
      Errorproc := newerrorproc;
   end else ioE := eNIL;
end;

function eGetCodeName(code: longint): string;
begin
   case code of
      eNONE: result := esNONE;
      eERR: result := esERR;
      eNO_MEMORY: result := esNO_MEMORY;
      eUNABLE: result := esUNABLE;
      eEXTERNAL: result := esEXTERNAL;
      eUNEXPECTED: result := esUNEXPECTED;
      eFAIL: result := esFAIL;
      eIO: result := esIO;
      eWRITE: result := esWRITE;
      eREAD: result := esREAD;
      eHARDWARE_FAILURE: result := esHARDWARE_FAILURE;
      eMEMORY: result := esMEMORY;
      eCANT_FREE: result := esCANT_FREE;
      eNIL: result := esNIL;
      eNOT_NIL: result := esNOT_NIL;
      eINVALID_ARG: result := esINVALID_ARG;
      eINVALID_ENV: result := esINVALID_ENV;
      eINVALID: result := esINVALID;
      eCORRUPTED: result := esCORRUPTED;
      eUNSUPPORTED: result := esUNSUPPORTED;
      eNOT_INITIALIZED: result := esNOT_INITIALIZED;
      eINITIALIZED: result := esINITIALIZED;
      eINITIALIZATION_FAIL: result := esINITIALIZATION_FAIL;
      eDEINITIALIZATION_FAIL: result := esDEINITIALIZATION_FAIL;
      eEMPTY: result := esEMPTY;
      eFULL: result := esFULL;
      eNOT_OPEN: result := esNOT_OPEN;
      eOPEN_FAIL: result := esOPEN_FAIL;
      eNOT_CLOSED: result := esNOT_CLOSED;
      eCLOSE_FAIL: result := esCLOSE_FAIL;
      eNOT_FOUND: result := esNOT_FOUND;
      else str(code, result);
   end;
end;

END.
